;òɶԵַķ
io8255_a    equ 230h       ; io8255_aΪַ230h
io8255_b    equ 231h       ; io8255_bΪַ231h
io8255_c    equ 232h       ; io8255_cΪַ232h
io8255_k    equ 233h       ; io8255_kΪַ233h
io8253_0    equ 210h       ; io8253_0Ϊַ210h
io8253_1    equ 211h       ; io8253_1Ϊַ211h
io8253_k    equ 213h       ; io8253_kΪַ213h
io8259_0    equ 200h       ; io8259_0Ϊַ200h
io8259_1    equ 201h       ; io8259_1Ϊַ201h
AD_START    equ   220H      ; AD_STARTΪַ220h
AD_OE   equ   221H         ; AD_OEΪַ221h
AD_EOI  equ   222H        ; AD_EOIΪַ222h

; ݶζ
data        segment
    count1  dw  0               ; жϼ
    portcl  db  81h,41h,24h,22h,0ffh   ; ̵״̬
    input   db  ?               ; ȡλ
    buf db  0               ; 
data        ends

; ջζ
st_ssg      segment stack
    db  256 dup(?)
st_ssg      ends

; ζ
code    segment
    assume  cs:code, ds:data, ss:st_ssg
start:
    cli                       ; ж
    mov ax, data              ; ݶεֵַaxĴ
    mov ds, ax                ; axĴֵdsĴ

    ; ʼ8259оƬ
    mov dx, io8259_0           ; io8259_0ĵֵַdxĴ
    mov al, 00010011B         ; ʼ1
    out dx, al
    mov dx, io8259_1           ; io8259_1ĵֵַdxĴ
    mov al, 00001000B         ; ʼ2
    out dx, al
    mov al, 00000001B         ; ʼ4
    out dx, al

    ; ж
    push    ds
    mov ax, 0
    mov ds, ax
    lea ax, cs:int_proc      ; int_procڵֵַaxĴ
    mov si, 08h              ; MIR008h
    add si, si
    add si, si  
    mov ds:[si], ax          ; axĴֵ洢жеipλ
    push    cs
    pop ax
    mov ds:[si+2], ax        ; axĴֵ洢жеcsλ
    pop ds
    in  al, dx
    and al, 11111110b
    out dx, al

    ; ʼ8253Ƶ
    mov ax, 0
    mov al, 00110110b
    mov dx, io8253_k
    out dx, al
    mov ax, 10000
    mov dx, io8253_0
    out dx, al
    mov al, ah
    out dx, al

    ; ʼ8255оƬ
    mov dx, io8255_k
    mov al, 10001000b
    out dx, al

    mov buf, 33h
    sti                     ; ж

    ; AD0809ת
lop1:   mov dx, AD_START
    out dx, al
l1: mov dx, AD_EOI
    in  al, dx
    test    al, 01h
    jz  l1
    mov dx, AD_OE
    in  al, dx
    mov input, al

;------------------------------------------------------------------
out1:   mov al, buf
    mov dx, io8255_c
    out dx, al

lop:    call    delay
    mov dx, io8255_c
    in  al, dx

sam:    test    al, 80h
    jnz nx0
    mov al, buf
    ror al, 1           ; ת
    jmp nx1
nx0:    mov al, buf
    rol al, 1           ; ת
nx1:    mov dx, io8255_c
    out dx, al
    mov buf, al

;-----------------------------------ͨʾ--------------------------
light:
    call    digital

    mov dx, io8255_b
greeen1:cmp count1, 500     ; жǷ5sɵͨ
    ja  yellow1
    mov al, portcl
    out dx, al
    jmp ok
yellow1:cmp count1, 700     ; жǷ2sɵƵ״̬
    ja  greeen2
    mov al, portcl[1]
    out dx, al
    jmp ok
greeen2:cmp count1, 1000        ; жǷ3sӸɵͨ
    ja  yellow2
    mov al, portcl[2]
    out dx, al
    jmp ok
yellow2:cmp count1, 1200        ; жǷ2sӸɵƵ״̬
    ja  finish
    mov al, portcl[3]
    out dx, al
    jmp ok
finish: mov count1, 0       ; һѭcount1Ϊ0
ok: call    digital
    jmp lop1

;---------------------------ʱʾ-----------------------------
digital proc
begin:
    mov dx, io8255_a
zhu5:   cmp count1, 100
    ja  zhu4
    mov al, 6Dh
    out dx, al
    jmp exit
zhu4:   cmp count1, 200
    ja  zhu3
    mov al, 66h
    out dx, al
    jmp exit
zhu3:   cmp count1, 300
    ja  zhu2
    mov al, 4Fh
    out dx, al
    jmp exit
zhu2:   cmp count1, 400
    ja  zhu1
    mov al, 5Bh
    out dx, al
    jmp exit
zhu1:   cmp count1, 500
    ja  zhu22
    mov al, 06h
    out dx, al
    jmp exit
zhu22:  cmp count1, 600
    ja  zhu11
    mov al, 5Bh
    out dx, al
    jmp exit
zhu11:  cmp count1, 700
    ja  zhi3
    mov al, 06h
    out dx, al
    jmp exit
zhi3:   cmp count1, 800
    ja  zhi2
    mov al, 4Fh
    out dx, al
    jmp exit
zhi2:   cmp count1, 900
    ja  zhi1
    mov al, 5Bh
    out dx, al
    jmp exit
zhi1:   cmp count1, 1000
    ja  zhi22
    mov al, 06h
    out dx, al
    jmp exit
zhi22:  cmp count1, 1100
    ja  zhi11
    mov al, 5Bh
    out dx, al
    jmp exit
zhi11:  cmp count1, 1200
    ja  exit
    mov al, 06h
    out dx, al
exit:   ret
digital endp

;------------------------------ʱ---------------------------------
delay   proc    near
    push    ax
    push    cx
    push    dx
    mov dl, input   
x1: mov cx, 0ffh
x2: loop    x2
    dec dl
    jnz x1
    pop dx
    pop cx
    pop ax
    ret
delay   endp

;-----------------------------жϷ---------------------------------
int_proc    proc    far
    push    ax
    push    dx
int1:   inc count1
    mov al, 20h
    mov dx, io8259_0
    out dx, al
    pop dx
    pop ax
    sti
    iret
int_proc    endp

code    ends
end start